//     DS1820

unsigned char OW_BUF[9];

unsigned char reset(int vivod)   //  ds1820
{
   unsigned char error=0;      //   

   restart_wdt();
   switch (vivod)
   {
      case 0: TRISB0=0; output_bit(PIN_B0,0); break;
      case 1: TRISB1=0; output_bit(PIN_B1,0); break;
      case 2: TRISB2=0; output_bit(PIN_B2,0); break;
   }
                      //     
   //RA0=0;                  //   
   delay_us(500);            //   ,  480 
   switch (vivod)
   {
      case 0: TRISB0=1; break;
      case 1: TRISB1=1; break;
      case 2: TRISB2=1; break;
   }
   //TRISA0=1;               //   ,  
   //    
   delay_us(55);               //       60-240 
   
   switch (vivod)
   {
      case 0: if(input(forward)) error=1; break;
      case 1: if(input(home)) error=1; break;
      case 2: if(input(street)) error=1; break;
      default: error=0; break;
   }
   //if(ds_home==1)            //    
   //error=1;
   
   delay_ms(1);                  //    

   //PORTA=3;
   //TRISA=0;
   
   return error;               
}

//   DS18B20
void command_1w(unsigned char comm,int vivod)
{
   unsigned char n;
   switch (vivod)
   {
      case 0: TRISB0=0; break;
      case 1: TRISB1=0; break;
      case 2: TRISB2=0; break;
   }
   //TRISA0=0;                  //  
   restart_wdt();
   disable_interrupts(GLOBAL);
   //     8 
   for(n=0;n<8;n++)
   {
      //ds_home=0;               //        
       switch (vivod)
      {
         case 0: output_bit(PIN_B0,0); break;
         case 1: output_bit(PIN_B1,0); break;
         case 2: output_bit(PIN_B2,0); break;
      }
      //ds_home=1;
      if(comm&0x01)               //   1  
      {
           switch (vivod)
         {
            case 0: output_bit(PIN_B0,1); break;
            case 1: output_bit(PIN_B1,1); break;
            case 2: output_bit(PIN_B2,1); break;
         }
      
          delay_us(60);               // 60-120 , 30      
      //RA0=1;                  //  ,   
         switch (vivod)
         {
            case 0: output_bit(PIN_B0,1); break;
            case 1: output_bit(PIN_B1,1); break;
            case 2: output_bit(PIN_B2,1); break;
         }
      // 
         comm>>=1;                  //   
      }
   }
   enable_interrupts(GLOBAL);
   
}

// 
unsigned int read_1w(int vivod)
{
   unsigned char n,temp;
   temp=0;                     //  
   //restart_wdt();
   disable_interrupts(GLOBAL);
   for(n=0;n<8;n++)
   {
      temp>>=1;                  //     ,     
      //TRISA0=0;
      //ds_home=0;               // ,  
      switch (vivod)
       {
         case 0: TRISB0=0; output_bit(PIN_B0,0); break;
         case 1: TRISB1=0; output_bit(PIN_B1,0); break;
         case 2: TRISB2=0; output_bit(PIN_B2,0); break;
      }
      delay_us(5);               //      
     //TRISA0=1;                  //   
     switch (vivod)
      {
         case 0: TRISB0=1; break;
         case 1: TRISB1=1; break;
         case 2: TRISB2=1; break;
      }
      
     //if(ds_home==1)                //    
         // temp|=0x80;            
    switch (vivod)
      {
         case 0: if(input(forward)) temp|=0x80; break;
         case 1: if(input(home)) temp|=0x80; break;
         case 2: if(input(street)) temp|=0x80; break;
         default: break;
      }     
    delay_us(55);               //  
      
   }
   enable_interrupts(GLOBAL);
   //TRISA0=1;
   switch (vivod)
      {
         case 0: TRISB0=1; break;
         case 1: TRISB1=1; break;
         case 2: TRISB2=1; break;
      }
   return temp;                  // 
}


   
 
 
 //       
void read_temp(int vivod)
 {
   unsigned char MS_byte,LS_byte,temp;
   MS_byte=0;       //    
   //restart_wdt();
  
      reset(vivod);
     command_1w(0xcc,vivod);               //    
      command_1w(0xbe,vivod);           // ,   
      LS_byte=read_1w(vivod);             //  
      MS_byte=read_1w(vivod);          //  ----------------------
   //     ,   
   
   
   
   //restart_wdt();
   if(MS_byte)     //           
   {
      ds_hm.znak=1;      //    
   ds_hm.term=((~LS_byte)+1);
    ds_hm.term>>=1;   //  , 0.5 
   }
   else
   {
    LS_byte>>=1;   // 
     ds_hm.term=LS_byte;
   ds_hm.znak=0;
   }
}

//    , crc
void read_crc(int vivod)                  
{
    unsigned char i;
    unsigned char buf[9];
   reset(vivod);
    command_1w(0xcc,vivod);
    command_1w(0xbe,vivod); // ,   
   for(i=0;i<9;i++)
   {
      OW_BUF[i]=read_1w(vivod); //     
    }  
} 


unsigned char DLcrc8 ( unsigned char *pData, unsigned char counterBytes )
 { 
     unsigned char  crc;
     unsigned char  data;
     unsigned char i,fb,st_byt;

     crc =0;                        // 
   do                                       //   
    { 
       data = *pData++;                     //  
       for (i=0;i<8;i++)               //    
        {
       fb =crc  ^ data;                  // ,     
      fb&=1;                        // 100110001,   100011001,   
        crc >>= 1;                       //    
        data >>= 1;
      if (fb == 1)crc^=0x8c;// ,  1000 1100
      }
    }
   while (counterBytes-- );
   return crc;
 }


unsigned char Check_Valid_Key(int vivod)
{
   unsigned char i,CRC,temp;
   CRC=0;
    for(i=0;i<9;i++)
      OW_BUF[i]=0;
   read_crc(vivod);                     //  
   CRC=DLcrc8(OW_BUF,7);         //   
   if(CRC==OW_BUF[8]) 
      return(1);   //       
   return(0);
}
