#include "Lexa_kotel.h"
#include "my_lcd.c"
#include "DS1820.c"

void bcd(unsigned int);
void setup_();

#int_RTCC
void  RTCC_isr(void) 
{

   if(ykaz_time->temp_time<65356)
   {
      ykaz_time->flag=1;
      ykaz_time->temp_time+=5000000;
   }
   
   if(ykaz_time->flag)
   {
      ykaz_time->sec+=1;
      
      if(ykaz_time->sec>=60)
      {
         ykaz_time->min+=1;
         ykaz_time->sec=0;
      }
      
      if(ykaz_time->min>=60)
      {
         ykaz_time->min=0;
         ykaz_time->hour+=1;
      }
      
      if(ykaz_time->hour>=24)
      {
         ykaz_time->hour=0;
      }
      
      ykaz_time->flag=0;
   }
   
   ykaz_time->temp_time-=65356;
}

#int_TIMER1
void  TIMER1_isr(void) 
{
   //  , 13*10=130 
   if (input(setup)) 
   { 
      if (ykaz_setup->open) --ykaz_setup->open; 
      ykaz_setup->close=10;    
   } 
   else 
   { 
      if (ykaz_setup->close) --ykaz_setup->close; 
      ykaz_setup->open=10;    
   }
   
   //  , 13*10=130 
   if (input(plus)) 
   { 
      if (ykaz_plus->open) --ykaz_plus->open; 
      ykaz_plus->close=10;    
   } 
   else 
   { 
      if (ykaz_plus->close) --ykaz_plus->close; 
      ykaz_plus->open=10;    
   }
   
   //  , 13*10=130 
   if (input(minus)) 
   { 
      if (ykaz_minus->open) --ykaz_minus->open; 
      ykaz_minus->close=10;    
   } 
   else 
   { 
      if (ykaz_minus->close) --ykaz_minus->close; 
      ykaz_minus->open=10;    
   }
}

#int_TIMER2
void  TIMER2_isr(void) 
{

}



void main()
{

   setup_adc_ports(NO_ANALOGS);
   setup_adc(ADC_OFF);
   setup_psp(PSP_DISABLED);
   setup_spi(SPI_SS_DISABLED);
   setup_wdt(WDT_18MS);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_256);  //  256*256
   setup_timer_1(T1_INTERNAL|T1_DIV_BY_1);     //   13 vc
   setup_timer_2(T2_DIV_BY_4,250,10);           //   100 
   setup_comparator(NC_NC_NC_NC);
   setup_vref(FALSE);
   enable_interrupts(INT_RTCC);
   enable_interrupts(INT_TIMER1);
   enable_interrupts(INT_TIMER2);
   enable_interrupts(GLOBAL);

   // 
   ykaz_time=&struct_time;
   ykaz_ystavki=&struct_ystavki;
   ykaz_setup=&struct_setup;
   ykaz_plus=&struct_plus;
   ykaz_minus=&struct_minus;
   
   // 
   set_tris_A(0x07);  //  
   set_tris_B(0xFF);  // 
   //output_B(00);
   set_tris_C(00);    // 
   set_tris_D(00);    // 
   output_D(00);      // 
   set_tris_E(00);
   output_E(00);
   
   // 
   lcd_init();
   delay_ms(6);

   //         
   ykaz_ystavki->temper=read_eeprom(1);
   ykaz_ystavki->interval=read_eeprom(2);
   ykaz_ystavki->on_off=read_eeprom(3);
   ykaz_time->temp_time=5000000;
   ykaz_setup->close=10;
   ykaz_plus->close=10;
   ykaz_minus->close=10;
   restart_wdt();
   
   //
   
   //      temp_time=5000000
   //  65536      65536, 
   // 5000000    flag   
   
   //     ,  : 
   //      ,  
   // 
   
   //   1)  2)  3)
   
   //      1)  2)
   
   //  ,      
   //   
   
   while(1)
   {
      // 
      
      lcd_gotoxy(11,1);
      bcd(ykaz_time->hour);
      lcd_putc(dec+0x30);
      lcd_putc(edin+0x30);
      lcd_putc(":");
      bcd(ykaz_time->min);
      lcd_putc(dec+0x30);
      lcd_putc(edin+0x30);
      restart_wdt();
      
      //  ,      
      // ,  
      if(!ykaz_setup->close)
         setup_();
         
      //       
      read_temp(1);
   }
   
   
}

void bcd(unsigned int hislo)
   {
      int temp_bcd,temp_bcd2;
      restart_wdt();
      //  ,  
      sotni=hislo/100;
      temp_bcd2=sotni*100;
      temp_bcd=hislo-(temp_bcd2);
      dec=temp_bcd/10;
      edin=hislo-temp_bcd2-dec*10;
   }
   
void setup_()
{
   //  
   output_D(00);
   
   //     
     while(!ykaz_setup->close) restart_wdt();
     ykaz_setup->open=0;  //     
     
     lcd_putc("\f");
     lcd_gotoxy(4,1);
     lcd_putc("Setup");
   //      
   //
   //==================================================================
   do{
   
     lcd_gotoxy(1,2);
     lcd_putc("min=");
     bcd(ykaz_time->min);
     lcd_putc(dec+0x30);
     lcd_putc(edin+0x30);
     
     if(!ykaz_plus->close)
       ykaz_time->min++;
       if(ykaz_time->min>=60) ykaz_time->min=0;
     while(!ykaz_plus->close) restart_wdt();
     
     if(!ykaz_minus->close)
       ykaz_time->min--;
       if(ykaz_time->min>=60) ykaz_time->min=0;
     while(!ykaz_minus->close) restart_wdt();
     
     //     setup
     restart_wdt();
    }while(!ykaz_setup->open);
    
    delay_ms(150);
    //     
     while(!ykaz_setup->close) restart_wdt();
     ykaz_setup->open=0;  //     
     
    // 
    //==============================================================
    do{
   
     lcd_gotoxy(1,2);
     lcd_putc("hour=");
     bcd(ykaz_time->hour);
     lcd_putc(dec+0x30);
     lcd_putc(edin+0x30);
     
     if(!ykaz_plus->close)
       ykaz_time->hour++;
       if(ykaz_time->hour>=24) ykaz_time->hour=0;
     while(!ykaz_plus->close) restart_wdt();
     
     if(!ykaz_minus->close)
       ykaz_time->hour--;
       if(ykaz_time->hour>=60) ykaz_time->hour=0;
     while(!ykaz_minus->close) restart_wdt();
     
     //     setup
     restart_wdt();
    }while(!ykaz_setup->open);
    
    delay_ms(150);
    //     
     while(!ykaz_setup->close) restart_wdt();
     ykaz_setup->open=0;  //     
     
     //  
     //==================================================================
      do{
   
     lcd_gotoxy(1,2);
     lcd_putc("ystav=");
     bcd(ykaz_ystavki->temper);
     lcd_putc("+");
     lcd_putc(dec+0x30);
     lcd_putc(edin+0x30);
     
     if(!ykaz_plus->close)
       ykaz_ystavki->temper++;
       if(ykaz_ystavki->temper>=100) ykaz_ystavki->temper=0;
     while(!ykaz_plus->close) restart_wdt();
     
     if(!ykaz_minus->close)
       ykaz_ystavki->temper--;
       if(ykaz_ystavki->temper>=60) ykaz_ystavki->temper=0;
     while(!ykaz_minus->close) restart_wdt();
     
     //     setup
     restart_wdt();
    }while(!ykaz_setup->open);
    
    delay_ms(150);
    //     
     while(!ykaz_setup->close) restart_wdt();
     ykaz_setup->open=0;  //     
     
     //  
     //==================================================================
      do{
   
     lcd_gotoxy(1,2);
     lcd_putc("interval=");
     bcd(ykaz_ystavki->interval);
     lcd_putc(dec+0x30);
     lcd_putc(edin+0x30);
     
     if(!ykaz_plus->close)
       ykaz_ystavki->interval++;
       if(ykaz_ystavki->interval>=20) ykaz_ystavki->interval=0;
     while(!ykaz_plus->close) restart_wdt();
     
     if(!ykaz_minus->close)
       ykaz_ystavki->interval--;
       if(ykaz_ystavki->interval>=60) ykaz_ystavki->interval=0;
     while(!ykaz_minus->close) restart_wdt();
     
     //     setup
     restart_wdt();
    }while(!ykaz_setup->open);
    
    delay_ms(150);
    //     
     while(!ykaz_setup->close) restart_wdt();
     ykaz_setup->open=0;  //     
     
     //    
     //==================================================================
      do{
   
     lcd_gotoxy(1,2);
     lcd_putc("avtomatic=");
     if(ykaz_ystavki->on_off)
      lcd_putc("on ");
     else
      lcd_putc("off");
     
     if(!ykaz_plus->close)
       ykaz_ystavki->on_off=1;
     while(!ykaz_plus->close) restart_wdt();
     
     if(!ykaz_minus->close)
       ykaz_ystavki->on_off=0;
     while(!ykaz_minus->close) restart_wdt();
     
     if(ykaz_ystavki->on_off>=2) ykaz_ystavki->on_off=0;
     //     setup
     restart_wdt();
    }while(!ykaz_setup->open);
    
    delay_ms(150);
    //     
     while(!ykaz_setup->close) restart_wdt();
     ykaz_setup->open=0;  //     
     
     //   ,  
     //1-
     //2-
     //3-   
     write_eeprom(1,ykaz_ystavki->temper);
     restart_wdt();
     write_eeprom(2,ykaz_ystavki->interval);
     restart_wdt();
     write_eeprom(3,ykaz_ystavki->on_off);
     restart_wdt();
     lcd_putc("\f");
}
